package net.moonleay.gimble.mixin;

import net.minecraft.entity.Entity;
import net.minecraft.entity.player.PlayerEntity;
import net.moonleay.gimble.client.editor.ClientEditor;
import net.moonleay.gimble.client.editor.modes.ModeModifier;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.Shadow;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfo;

@Mixin(Entity.class)
public class NoClipMixin {

    @Shadow public boolean noClip;

    @Inject(method = "tick", at = @At(value = "HEAD"))
    private void enoClip(CallbackInfo ci) {
        // TODO: Add player check, add multiplayer compat
        if(!((Entity)(Object)this instanceof PlayerEntity)) // Only check on player
            return;

        if (!ClientEditor.INSTANCE.containsModifier(ModeModifier.NO_CLIP))
            return;
        PlayerEntity thePlayer = (PlayerEntity)(Object)this;
        if (!thePlayer.getAbilities().flying)
            return;

        this.noClip = true;
    }
}
